// version 1.1
namespace LinkLabel
{
    using System;
    using System.Drawing;
    using System.Runtime.CompilerServices;
    using System.Windows.Forms;

    public class LinkLabel
    {
        // autoscale fields
        public static object B4P_AutoScale = null;

        private bool bld = false;
        private Color cl = Color.Blue;
        private object[] eventObject;
        private int fntsize = 10;
        private Panel pnl = new Panel();
        private string strtext;
        private bool undline = true;

        public event EventHandler Click;

        public event EventHandler Paint;

        public LinkLabel(System.Windows.Forms.Control FormName, int Top, int Left, int Width, int Height)
        {
            this.pnl.Top = Top;
            this.pnl.Left = Left;
            this.pnl.Width = Width;
            this.pnl.Height = Height;
            this.pnl.BackColor = FormName.BackColor;
            FormName.Controls.Add(this.pnl);
            this.eventObject = new object[] { this, "Paint" };
            this.eventObject = new object[] { this, "Click" };
            this.pnl.Paint += new PaintEventHandler(this.pnl_Paint);
            this.pnl.Click += new EventHandler(this.pnl_Click);
        }

        private void pnl_Click(object sender, EventArgs e)
        {
            this.Click(this.eventObject, null);
        }

        private void pnl_Paint(object sender, PaintEventArgs e)
        {
            Graphics graphics = e.Graphics;
            Brush brush = new SolidBrush(this.cl);
            FontStyle regular = FontStyle.Regular;
            if (this.bld)
            {
                regular |= FontStyle.Bold;
            }
            if (this.undline)
            {
                regular |= FontStyle.Underline;
            }
            Font font = new Font(FontFamily.GenericSansSerif, (float) this.fntsize, regular);
            graphics.DrawString(this.strtext, font, brush, (float) 0f, (float) 0f);
            graphics.Dispose();
            brush.Dispose();
            font.Dispose();
        }

        public Color BackColor
        {
            get
            {
                return this.pnl.BackColor;
            }
            set
            {
                this.pnl.BackColor = value;
            }
        }

        public bool Bold
        {
            get
            {
                return this.bld;
            }
            set
            {
                this.bld = value;
                this.pnl.Refresh();
            }
        }

        public Panel Control
        {
            get
            {
                return this.pnl;
            }
            set
            {
                this.pnl = value;
            }
        }

        public double DllVersion
        { get { return 1.1; } }

        public bool Enabled
        {
            get
            {
                return this.pnl.Enabled;
            }
            set
            {
                this.pnl.Enabled = value;
            }
        }

        public Color FontColor
        {
            get
            {
                return this.cl;
            }
            set
            {
                this.cl = value;
                this.pnl.Refresh();
            }
        }

        public int FontSize
        {
            get
            {
                return this.fntsize;
            }
            set
            {
                this.fntsize = value;
                this.pnl.Refresh();
            }
        }

        public int Height
        {
            get
            {
                return this.pnl.Height;
            }
            set
            {
                this.pnl.Height = value;
            }
        }

        public int Left
        {
            get
            {
                return this.pnl.Left;
            }
            set
            {
                this.pnl.Left = value;
            }
        }

        public string Text
        {
            get
            {
                return this.strtext;
            }
            set
            {
                this.strtext = value;
                this.pnl.Refresh();
            }
        }

        public int Top
        {
            get
            {
                return this.pnl.Top;
            }
            set
            {
                this.pnl.Top = value;
            }
        }

        public bool Underline
        {
            get
            {
                return this.undline;
            }
            set
            {
                this.undline = value;
                this.pnl.Refresh();
            }
        }

        public bool Visible
        {
            get
            {
                return this.pnl.Visible;
            }
            set
            {
                this.pnl.Visible = value;
            }
        }

        public int Width
        {
            get
            {
                return this.pnl.Width;
            }
            set
            {
                this.pnl.Width = value;
            }
        }
    }
}
